<template>
  <q-page class="mapPage">
      <yandex-map
        class="main-map"
        :zoom="11"
        style="width: 100%; height: calc(100vh - 213px);"
        :coords="coords"
        :controls="['geolocationControl', 'fullscreenControl']"
        :settings="settings"
        @map-was-initialized="onMapReady"
      >
        <ymap-marker
          :coords="[marker.latitude , marker.longitude]"
          v-for="(marker, index) in markers"
          :key="index"
          :marker-id="marker.id"
          rectangle
          :callbacks="{click: goEvent}"
        />
      </yandex-map>
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'
import { yandexMap, ymapMarker } from 'vue-yandex-maps'
export default {
  name: 'Map',
  data () {
    return {
      usercoords: null,
      coords: [50.77463, 30.353817],
      markers: [
        { 'latitude': 59.805788539572205, 'longitude': 30.37006839689214, id: 1 },
        { 'latitude': 59.844663324392656, 'longitude': 30.340186726761164, id: 2 },
        { 'latitude': 59.91368804527861, 'longitude': 30.265259650431837, id: 3 },
        { 'latitude': 59.96093569702121, 'longitude': 30.34890719755481, id: 4 },
        { 'latitude': 59.96976762792058, 'longitude': 30.27031779331309, id: 5 }
      ],
      settings: {
        apiKey: 'ab546df8-91b4-4f94-bb42-25d8a284e9dc',
        lang: 'ru_RU',
        coordorder: 'latlong',
        version: '2.1'
      }
    }
  },
  computed: {
    ...mapGetters({
      points: 'events/events'
    })
  },
  methods: {
    goEvent (marker) {
      this.$router.push({ name: 'events.card', params: { id: marker.get('target').properties._data.markerId } })
    },
    onMapReady (e) {
      let self = this
      window.ymaps.geolocation.get({
        mapStateAutoApply: true
      })
        .then(function (result) {
          let position = result.geoObjects.position.slice()
          self.coords = position
        })
    }
  },
  components: { yandexMap, ymapMarker }
}
</script>

<style scoped>
  .main-map{
    width: 100%;
    height: 120px;
  }
</style>
